//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

// Performs drawing and basic mouse tracking and interaction tasks on mode 1.
void ldraw() {
  if (drawrects) {
    for (int i=0, j=finrects.size();i<j;i++) {
      fill(255);
      noStroke();
      lrect lr=(lrect)finrects.get(i);
      lrect lr2=(lrect)caprects.get(i);
      rect(Xinit+lr.X*scl,lr.Y*scl,lr.W*scl,lr.H*scl);
      //Check whether mouse is over any item
      if (!shift && mouseX>Xinit+lr.X*scl+2 && mouseX<Xinit+(lr.X+lr.W)*scl-2 && mouseY>lr.Y*scl+2 && mouseY<(lr.Y+lr.H)*scl-2) {
        drawmouseover(lr);// draw labels
        in=0;
        currentmouseover=lr;
        if (currentmousedrag==null && mouse && !shift) {
          currentmousedrag=lr;
          tW=mouseX-(int)Xinit-(int)(lr.X*scl);
          tH=mouseY-(int)(lr.Y*scl);
        } else if (currentmousedrag!=null) {
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+lr.X*scl,lr.Y*scl,lr.W*scl,lr.H*scl);
        }
      } 
      else if (mouseX>Xinit+(lr.X+lr.W)*scl+2 && mouseX<Xinit+(lr2.X+lr2.W)*scl-2 && mouseY>lr.Y*scl+2 && mouseY<(lr.Y+lr.H)*scl-2 && currentmousedrag!=null) {
        in=2;
        currentmouseover=lr;
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+(lr.X+lr.W)*scl,lr.Y*scl,(lr2.W-lr.W)*scl,lr.H*scl);
      } 
      else if (mouseX>Xinit+lr.X*scl+2 && mouseX<Xinit+(lr.X+lr.W)*scl-2 && mouseY>(lr.Y+lr.H)*scl+2 && mouseY<(lr2.Y+lr2.H)*scl-2 && currentmousedrag!=null) {
        in=1;
        currentmouseover=lr;
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+lr.X*scl,(lr.Y+lr.H)*scl,lr.W*scl,(lr2.H-lr.H)*scl);
      }
    }
    fill(0,100,100,30);
    noStroke();
  }
  if (drawlines) {
    stroke(0,160);
    strokeWeight(1);
    for (int i=0,j=lines.size();i<j;i++) {
      lline l=(lline)lines.get(i);
      line(Xinit+l.X1*scl,l.Y1*scl,Xinit+l.X2*scl,l.Y2*scl);
      lrect lr=l.lr;
      if (!shift && mouseX>Xinit+l.X1*scl-2 && mouseX<Xinit+l.X2*scl+2 && mouseY>l.Y1*scl-2 && mouseY<l.Y2*scl+2) {
        currentmouseover=lr;
        if (currentmousedrag==null) {
          noStroke();
          fill(80);
          rect(Xinit+l.X1*scl,l.Y1*scl,50,16);
          fill(255);
          textFont(font, 11);
          text("^v swap",Xinit+l.X1*scl+5,l.Y1*scl+11);
        }
        stroke(0,160);
        strokeWeight(3);
        line(Xinit+l.X1*scl,l.Y1*scl,Xinit+l.X2*scl,l.Y2*scl);
        strokeWeight(1);
      }
    }
    stroke(0,160);
    strokeWeight(1);
    line(Xinit,pack.H*scl,Xinit+pack.W*scl,pack.H*scl);
    line(Xinit+pack.W*scl,0,Xinit+pack.W*scl,pack.H*scl);
  }
  if (currentmousedrag!=null && mouse) {
    stroke(160);
    strokeWeight(1);
    fill(255,120);
    rect(mouseX-tW, mouseY-tH,currentmousedrag.W*scl,currentmousedrag.H*scl);
  }
}
void draw1() {
  stroke(0);
  strokeWeight(1);
  line(0,Hmax*scl,width,Hmax*scl);
  stroke(255,120);
  line(0,depth*scl,width,depth*scl);
  fill(0);
  noStroke();
  textFont(font, 11);
  text("Hmax: "+Hmax,width-50,Hmax*scl-4);
  fill(255);
    text("Depth: "+depth,width-50,depth*scl-4);
  for (int i=0,j=initrects.size();i<j;i++) {
    drawrect((lrect)initrects.get(i));
  }
  if (tW>0 && tH>0) {
    fill(255);
    stroke(160);
    strokeWeight(2);
    rect(tX,tY,tW*scl,tH*scl);
    fill(0);
    textFont(font, 11);
    text((int)tW + "x" + (int)tH,tX+5,tY+16);
  }
  textrender("Draw Mode", "No. Items:" + initrects.size(), "Drag to create new items. Shift+Drag to adjust Depth and Height. Hit '2' to enter packing mode, '3' to enter perspective mode");
}

void draw2() {
  if (pack!=null) {
    ldraw();
    stroke(0);
    strokeWeight(1);
    line(0,Hmax*scl,width,Hmax*scl);
    stroke(255,120);
    line(0,depth*scl,width,depth*scl);
fill(0);
  noStroke();
  textFont(font, 11);
  text("Hmax: "+Hmax,width-50,Hmax*scl-4);
  fill(255);
    text("Depth: "+depth,width-50,depth*scl-4);
    float grossarea=pack.W*pack.H;
    textrender("Packing Mode", "Resulting Area: "+(int)grossarea+", Optimal Area: " + (int)pack.A + ", Percent Used: " + (int)((pack.A/grossarea)*100) + "%" + ". No. Items: " + (int)itemstopack + " No. Items Packed: " + (int)packeditems, "Shift+Drag to scroll or adjust Depth and Height. Hit '1' to enter draw mode,'3' to enter perspective mode. 'Q' toggles item display, 'W' toggles partition display.");
  }
}
// Drawing in perspective mode.
void draw3() {
  background(0);
  textrender("Perspective Mode", "Drag to zoom/rotate", "Hit '1' to enter drawing mode, '2' to enter packing mode. 'Q' toggles item display, 'W' toggles partition display");
  lights();
  translate(width/2,height/2);
  scale(scl+zoom3);
  rotateY(rot3/100);
  if (drawlines) {
    fill(255);
    noStroke();
    for (int i=0,j=lines.size();i<j;i++) {
      lline l=(lline)lines.get(i);
      pushMatrix();
      translate(l.X1-pack.W/2,l.Y1-pack.H/2,0);
      if (!l.lr.direction) { //row cut
        translate((l.X2-l.X1)/2,0,0);
        box(l.X2-l.X1,.3,depth);
      } 
      else {
        translate(0,(l.Y2-l.Y1)/2,0);
        box(.3,l.Y2-l.Y1,depth);
      }
      popMatrix();
    }
    for (int i=0,j=caprects.size();i<j;i++) {
      lrect lr=(lrect)caprects.get(i);
      lrect lr2=(lrect)finrects.get(i);
      pushMatrix();
      translate(lr.X-pack.W/2,lr.Y-pack.H/2,0);
      translate(lr.W/2,lr.H/2);
      if (lr2.capfront) {
        pushMatrix();
        translate(0,0,depth/2);
        box(lr.W,lr.H,.3);
        popMatrix();
      }
      if (lr2.caprear) {
        pushMatrix();
        translate(0,0,-depth/2);
        box(lr.W,lr.H,.3);
        popMatrix();
      }
      popMatrix();
    }
    pushMatrix();
    pushMatrix();
    translate(0,-pack.H/2,0);
    box(pack.W,.3,depth);
    popMatrix();
    pushMatrix();
    translate(0,pack.H/2,0);
    box(pack.W,.3,depth);
    popMatrix();
    pushMatrix();
    translate(-pack.W/2,0,0);
    box(.3,pack.H,depth);
    popMatrix();
    pushMatrix();
    translate(pack.W/2,0,0);
    box(.3,pack.H,depth);
    popMatrix();
    popMatrix();
  }
  fill(155);
  if (drawrects) {
    for (int i=0,j=finrects.size();i<j;i++) {
      lrect lr=(lrect)finrects.get(i);
      pushMatrix();
      translate(lr.X-pack.W/2,lr.Y-pack.H/2,0);
      translate(lr.W/2,lr.H/2);
      box(lr.W,lr.H,depth-2);
      popMatrix();
    }
  }
}
// Helper to draw initial rectangles (mode 0) along with labels
void drawrect(lrect lrin) {
  fill(255);
  stroke(160);
  strokeWeight(1);
  lrect lr=lrin;
  rect(lr.X,lr.Y,lr.W*scl,lr.H*scl);
  fill(0);
  stroke(255);
  strokeWeight(2);
  ellipse(lr.X,lr.Y,16,16);
  line(lr.X-4,lr.Y-4,lr.X+4,lr.Y+4);
  line(lr.X-4,lr.Y+4,lr.X+4,lr.Y-4);
  textFont(font, 11);
  text((int)lr.W + "x" + (int)lr.H,lr.X+5,lr.Y+16);
}
// Helper to draw labels of items when mouseover in mode 1. Also takes care of drawing
// frames when dragging
void drawmouseover(lrect lrin) {
  lrect lr=lrin;
  if (currentmousedrag==null) {
    fill(0);
    textFont(font, 11);
    text((int)lr.W+"x"+(int)lr.H,Xinit+lr.X*scl+5,lr.Y*scl+16);
    float tX=Xinit+lr.X*scl+5;
    float tY=lr.Y*scl+21;
    if (lr.caprear) {
      fill(255,220,0);
    } 
    else {
      fill(140);
    }
    rect(tX,tY,16,15);
    fill(255);
    noStroke();
    text("R",tX+3,tY+11);
    tX=Xinit+lr.X*scl+22;
    if (lr.capfront) {
      fill(255,220,0);
    } 
    else {
      fill(140);
    }
    rect(tX,tY,16,15);
    fill(255);
    text("F",tX+3,tY+11);
  } 
}
