import processing.core.*; import processing.opengl.*; import java.util.ArrayList; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class lpackern extends PApplet {//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/





PFont font, font2;                     // Fonts

float itemstopack=0, packeditems=0;    // Helper variables to display solution completeness
float scl=10;                          // Scale
float Xinit=0;                         // Scroll on mode 1
int Hmax=30;                           // Maximum height
int depth=10;                          // Depth in 3D
float zoom3=1;
float rot3=0;
int in=0;                              // A special helper variable that indicates whether a lrect is to be inserted
                                       // at the right or at the bottom, or to be swapped, when editing.
                                       // 0=swap, 1=bottom(row), 2=right(column)

ArrayList initrects=new ArrayList();   // Holds the unprocessed items
ArrayList finrects=new ArrayList();    // Holds the processed rectangle array
ArrayList caprects=new ArrayList();
ArrayList lines=new ArrayList();       // Holds the lines that separate finrects after processing
lrect pack=new lrect(100,Hmax,true);   // Initially specifies the free space, after processing
                                       //  stores the rectangle structure

int mode=0;                            // Denotes program mode
int tX=0, tY=0, tW=0, tH=0, dX=0, dY=0;// Helper variables to temporarily store dimensions of newly 
                                       //  created items or items that are being moved
boolean mouse=false;                   // Denotes a mousedown
boolean shift=false;
boolean draghmax=false;
boolean dragdepth=false;
boolean change=false;                  // Denotes a change in the initial array of finrects
boolean drawlines=true;                // Specifies drawing of lines
boolean drawrects=true;                // Specifies drawing of rectangles
lrect currentmouseover=null;           // Holds the item over which the cursor resides. Null if on none
lrect currentmousedrag=null;           // Holds the item which is dragged by the cursor. Null if none

public void setup() {
  size(800,600, OPENGL);
  hint(ENABLE_OPENGL_4X_SMOOTH);
  this.frame.setTitle("LPacker"); 
  frameRate(20);
  font=loadFont("HelveticaNeue-11.vlw"); 
  font2=loadFont("HelveticaNeue-20.vlw"); 
}
public void draw() {
  background(140);
  dX=mouseX-pmouseX;
  dY=mouseY-pmouseY;
  currentmouseover=null;
  if (mode==0) {
    draw1();
  } 
  else if (mode==1) {
    draw2();
  }
  else if (mode==2) {
    draw3();
  }
}
public void mousePressed() {
  if (!mouse && (mode==0 || mode==2)) {
    tX=mouseX;
    tY=mouseY;
  }
  
  if (((mode==0 && tW==0 && tH==0) || (mode==1 && currentmousedrag==null)) && mouseY>Hmax*scl-5 && mouseY<Hmax*scl+5 && shift) {
    draghmax=true;
  } else if (((mode==0 && tW==0 && tH==0) || (mode==1 && currentmousedrag==null)) && mouseY>depth*scl-5 && mouseY<depth*scl+5 && shift) {
    dragdepth=true;
  }
  mouse=true;
}
public void mouseDragged() {
  if (draghmax) {
    Hmax=(int)(mouseY/scl);
    recalc();
  } else if (dragdepth) {
    depth=(int)(mouseY/scl);
  } else if (mode==0) {
    tW=(int)((abs(mouseX-tX))/scl);
    tH=(int)((abs(mouseY-tY))/scl);
  } else if (mode==2 && mouse) {
      zoom3+=(float)dY/60;
      rot3+=(float)dX/5;
  } else if (mode==1 && shift) {
    Xinit+=(float)dX/3;
    if (Xinit>0) {Xinit=0;}
  }
}
public void mouseReleased() {
  dragdepth=draghmax=false;
  if (mode==0) {
    if (tW>0 && tH>0) {
      initrects.add(new lrect(tX,tY,tW,tH,false));
      tW=tH=0;
      change=true;
    } 
    else {
      for (int i=0;i<initrects.size();i++) {
        lrect lr=(lrect)initrects.get(i);
        float dx2=(lr.X-mouseX);
        dx2*=dx2;
        float dy2=(lr.Y-mouseY);
        dy2*=dy2;
        if (dx2+dy2<256) {
          initrects.remove(i);
          change=true;
        }
      }
    }
  }  
  else if (mode==1) {
    if (currentmouseover!=null && mouseX>Xinit+currentmouseover.X*scl+5 && mouseX<Xinit+currentmouseover.X*scl+21 && mouseY>currentmouseover.Y*scl+21 && mouseY<currentmouseover.Y*scl+36) {
      currentmouseover.caprear=!currentmouseover.caprear;
    } else if (currentmouseover!=null && mouseX>Xinit+currentmouseover.X*scl+22 && mouseX<Xinit+currentmouseover.X*scl+38 && mouseY>currentmouseover.Y*scl+21 && mouseY<currentmouseover.Y*scl+36) {
      currentmouseover.capfront=!currentmouseover.capfront;
    } else if (currentmousedrag!=null && currentmouseover!=null) {
      if (currentmouseover.leaf) {
        if (in==0) {
        lswap(currentmousedrag, currentmouseover);
        restruct();
        } else if (in==1 && currentmouseover!=currentmousedrag) {
          lrect lrt=new lrect();
          lrect lrt2=new lrect();
          lrt.clonefrom(currentmouseover);
          lrt2.clonefrom(currentmousedrag);
          lrect lrt3=new lrect(lrt,lrt2,false);
          currentmouseover.clonefrom(lrt3);
          currentmousedrag.free=true;
          restruct();
        } else if (in==2 && currentmouseover!=currentmousedrag) {
          lrect lrt=new lrect();
          lrect lrt2=new lrect();
          lrt.clonefrom(currentmouseover);
          lrt2.clonefrom(currentmousedrag);
          lrect lrt3=new lrect(lrt,lrt2,true);
          currentmouseover.clonefrom(lrt3);
          currentmousedrag.free=true;
          restruct();
        }
      } else if (currentmouseover.lr1!=currentmousedrag){
        lrect lrt1=new lrect();
        lrect lrt2=new lrect();
        lrt1.clonefrom(currentmouseover.lr1);
        lrt2.clonefrom(currentmousedrag);
        currentmouseover.lr1=new lrect(lrt1,lrt2,currentmouseover.direction);
        currentmousedrag.free=true;
        restruct();
        
      }
    }
    else if (currentmouseover!=null) {
      currentmouseover.mirror();
      restruct();
      currentmouseover=null;
    }
  }
  mouse=false;
  currentmousedrag=null;
}


public void keyPressed() {
  if (key==CODED && keyCode==SHIFT) {
    shift=true;
  }
  if (key=='1') {
    // Enter draw mode
    mode=0;
    tX=tY=tW=tH=0;
  } 
  else if (key=='2') {
    // Enter packing mode
    mode=1;
    if (change) {
    recalc();
    }
  }
  else if (key=='3') {
   // Enter 3D mode
   mode=2;
   if (change) {
    recalc();
    } 
  }
  // Draw positioned items
  else if (key=='q') {
    drawrects=!drawrects;
  } 
  // Draw separation lines
  else if (key=='w') {
    drawlines=!drawlines;
  }
}

public void keyReleased() {
  shift=false;
}

//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

// Various Bubble Sort Algorithms: By Width, Height, Area, Squareness etc.
public void bubblesortw(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.W>lr1.W) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
public void bubblesorth(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.H>lr1.H) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
public void bubblesorta(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.A>lr1.A) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
public void bubblesorts(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (abs(lr2.W-lr2.H)<abs(lr1.W-lr1.H)) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
public void bubblesortp(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.W+lr2.H<lr1.W+lr1.H) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}

//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

// Performs drawing and basic mouse tracking and interaction tasks on mode 1.
public void ldraw() {
  if (drawrects) {
    for (int i=0, j=finrects.size();i<j;i++) {
      fill(255);
      noStroke();
      lrect lr=(lrect)finrects.get(i);
      lrect lr2=(lrect)caprects.get(i);
      rect(Xinit+lr.X*scl,lr.Y*scl,lr.W*scl,lr.H*scl);
      //Check whether mouse is over any item
      if (!shift && mouseX>Xinit+lr.X*scl+2 && mouseX<Xinit+(lr.X+lr.W)*scl-2 && mouseY>lr.Y*scl+2 && mouseY<(lr.Y+lr.H)*scl-2) {
        drawmouseover(lr);// draw labels
        in=0;
        currentmouseover=lr;
        if (currentmousedrag==null && mouse && !shift) {
          currentmousedrag=lr;
          tW=mouseX-(int)Xinit-(int)(lr.X*scl);
          tH=mouseY-(int)(lr.Y*scl);
        } else if (currentmousedrag!=null) {
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+lr.X*scl,lr.Y*scl,lr.W*scl,lr.H*scl);
        }
      } 
      else if (mouseX>Xinit+(lr.X+lr.W)*scl+2 && mouseX<Xinit+(lr2.X+lr2.W)*scl-2 && mouseY>lr.Y*scl+2 && mouseY<(lr.Y+lr.H)*scl-2 && currentmousedrag!=null) {
        in=2;
        currentmouseover=lr;
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+(lr.X+lr.W)*scl,lr.Y*scl,(lr2.W-lr.W)*scl,lr.H*scl);
      } 
      else if (mouseX>Xinit+lr.X*scl+2 && mouseX<Xinit+(lr.X+lr.W)*scl-2 && mouseY>(lr.Y+lr.H)*scl+2 && mouseY<(lr2.Y+lr2.H)*scl-2 && currentmousedrag!=null) {
        in=1;
        currentmouseover=lr;
        noFill();
        stroke(0);
        strokeWeight(3);
        rect(Xinit+lr.X*scl,(lr.Y+lr.H)*scl,lr.W*scl,(lr2.H-lr.H)*scl);
      }
    }
    fill(0,100,100,30);
    noStroke();
  }
  if (drawlines) {
    stroke(0,160);
    strokeWeight(1);
    for (int i=0,j=lines.size();i<j;i++) {
      lline l=(lline)lines.get(i);
      line(Xinit+l.X1*scl,l.Y1*scl,Xinit+l.X2*scl,l.Y2*scl);
      lrect lr=l.lr;
      if (!shift && mouseX>Xinit+l.X1*scl-2 && mouseX<Xinit+l.X2*scl+2 && mouseY>l.Y1*scl-2 && mouseY<l.Y2*scl+2) {
        currentmouseover=lr;
        if (currentmousedrag==null) {
          noStroke();
          fill(80);
          rect(Xinit+l.X1*scl,l.Y1*scl,50,16);
          fill(255);
          textFont(font, 11);
          text("^v swap",Xinit+l.X1*scl+5,l.Y1*scl+11);
        }
        stroke(0,160);
        strokeWeight(3);
        line(Xinit+l.X1*scl,l.Y1*scl,Xinit+l.X2*scl,l.Y2*scl);
        strokeWeight(1);
      }
    }
    stroke(0,160);
    strokeWeight(1);
    line(Xinit,pack.H*scl,Xinit+pack.W*scl,pack.H*scl);
    line(Xinit+pack.W*scl,0,Xinit+pack.W*scl,pack.H*scl);
  }
  if (currentmousedrag!=null && mouse) {
    stroke(160);
    strokeWeight(1);
    fill(255,120);
    rect(mouseX-tW, mouseY-tH,currentmousedrag.W*scl,currentmousedrag.H*scl);
  }
}
public void draw1() {
  stroke(0);
  strokeWeight(1);
  line(0,Hmax*scl,width,Hmax*scl);
  stroke(255,120);
  line(0,depth*scl,width,depth*scl);
  fill(0);
  noStroke();
  textFont(font, 11);
  text("Hmax: "+Hmax,width-50,Hmax*scl-4);
  fill(255);
    text("Depth: "+depth,width-50,depth*scl-4);
  for (int i=0,j=initrects.size();i<j;i++) {
    drawrect((lrect)initrects.get(i));
  }
  if (tW>0 && tH>0) {
    fill(255);
    stroke(160);
    strokeWeight(2);
    rect(tX,tY,tW*scl,tH*scl);
    fill(0);
    textFont(font, 11);
    text((int)tW + "x" + (int)tH,tX+5,tY+16);
  }
  textrender("Draw Mode", "No. Items:" + initrects.size(), "Drag to create new items. Shift+Drag to adjust Depth and Height. Hit '2' to enter packing mode, '3' to enter perspective mode");
}

public void draw2() {
  if (pack!=null) {
    ldraw();
    stroke(0);
    strokeWeight(1);
    line(0,Hmax*scl,width,Hmax*scl);
    stroke(255,120);
    line(0,depth*scl,width,depth*scl);
fill(0);
  noStroke();
  textFont(font, 11);
  text("Hmax: "+Hmax,width-50,Hmax*scl-4);
  fill(255);
    text("Depth: "+depth,width-50,depth*scl-4);
    float grossarea=pack.W*pack.H;
    textrender("Packing Mode", "Resulting Area: "+(int)grossarea+", Optimal Area: " + (int)pack.A + ", Percent Used: " + (int)((pack.A/grossarea)*100) + "%" + ". No. Items: " + (int)itemstopack + " No. Items Packed: " + (int)packeditems, "Shift+Drag to scroll or adjust Depth and Height. Hit '1' to enter draw mode,'3' to enter perspective mode. 'Q' toggles item display, 'W' toggles partition display.");
  }
}
// Drawing in perspective mode.
public void draw3() {
  background(0);
  textrender("Perspective Mode", "Drag to zoom/rotate", "Hit '1' to enter drawing mode, '2' to enter packing mode. 'Q' toggles item display, 'W' toggles partition display");
  lights();
  translate(width/2,height/2);
  scale(scl+zoom3);
  rotateY(rot3/100);
  if (drawlines) {
    fill(255);
    noStroke();
    for (int i=0,j=lines.size();i<j;i++) {
      lline l=(lline)lines.get(i);
      pushMatrix();
      translate(l.X1-pack.W/2,l.Y1-pack.H/2,0);
      if (!l.lr.direction) { //row cut
        translate((l.X2-l.X1)/2,0,0);
        box(l.X2-l.X1,.3f,depth);
      } 
      else {
        translate(0,(l.Y2-l.Y1)/2,0);
        box(.3f,l.Y2-l.Y1,depth);
      }
      popMatrix();
    }
    for (int i=0,j=caprects.size();i<j;i++) {
      lrect lr=(lrect)caprects.get(i);
      lrect lr2=(lrect)finrects.get(i);
      pushMatrix();
      translate(lr.X-pack.W/2,lr.Y-pack.H/2,0);
      translate(lr.W/2,lr.H/2);
      if (lr2.capfront) {
        pushMatrix();
        translate(0,0,depth/2);
        box(lr.W,lr.H,.3f);
        popMatrix();
      }
      if (lr2.caprear) {
        pushMatrix();
        translate(0,0,-depth/2);
        box(lr.W,lr.H,.3f);
        popMatrix();
      }
      popMatrix();
    }
    pushMatrix();
    pushMatrix();
    translate(0,-pack.H/2,0);
    box(pack.W,.3f,depth);
    popMatrix();
    pushMatrix();
    translate(0,pack.H/2,0);
    box(pack.W,.3f,depth);
    popMatrix();
    pushMatrix();
    translate(-pack.W/2,0,0);
    box(.3f,pack.H,depth);
    popMatrix();
    pushMatrix();
    translate(pack.W/2,0,0);
    box(.3f,pack.H,depth);
    popMatrix();
    popMatrix();
  }
  fill(155);
  if (drawrects) {
    for (int i=0,j=finrects.size();i<j;i++) {
      lrect lr=(lrect)finrects.get(i);
      pushMatrix();
      translate(lr.X-pack.W/2,lr.Y-pack.H/2,0);
      translate(lr.W/2,lr.H/2);
      box(lr.W,lr.H,depth-2);
      popMatrix();
    }
  }
}
// Helper to draw initial rectangles (mode 0) along with labels
public void drawrect(lrect lrin) {
  fill(255);
  stroke(160);
  strokeWeight(1);
  lrect lr=lrin;
  rect(lr.X,lr.Y,lr.W*scl,lr.H*scl);
  fill(0);
  stroke(255);
  strokeWeight(2);
  ellipse(lr.X,lr.Y,16,16);
  line(lr.X-4,lr.Y-4,lr.X+4,lr.Y+4);
  line(lr.X-4,lr.Y+4,lr.X+4,lr.Y-4);
  textFont(font, 11);
  text((int)lr.W + "x" + (int)lr.H,lr.X+5,lr.Y+16);
}
// Helper to draw labels of items when mouseover in mode 1. Also takes care of drawing
// frames when dragging
public void drawmouseover(lrect lrin) {
  lrect lr=lrin;
  if (currentmousedrag==null) {
    fill(0);
    textFont(font, 11);
    text((int)lr.W+"x"+(int)lr.H,Xinit+lr.X*scl+5,lr.Y*scl+16);
    float tX=Xinit+lr.X*scl+5;
    float tY=lr.Y*scl+21;
    if (lr.caprear) {
      fill(255,220,0);
    } 
    else {
      fill(140);
    }
    rect(tX,tY,16,15);
    fill(255);
    noStroke();
    text("R",tX+3,tY+11);
    tX=Xinit+lr.X*scl+22;
    if (lr.capfront) {
      fill(255,220,0);
    } 
    else {
      fill(140);
    }
    rect(tX,tY,16,15);
    fill(255);
    text("F",tX+3,tY+11);
  } 
}

//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * 
 * This is the actual data structure that becomes the
 * building block of the tree.
 * Its basic properties are its dimensions, its children and its type (leaf, free)
 * 
 * It contains facilities for:
 * - Automatically finding areas denoted as free to insert a spcecified element(returns false otherwise)
 * - Recalculating the dimensions of all the children elements based on the leaf elements(real dimensions)
 * - Recalculating real free space after any transformation
 * - Swapping its children
 */

// X and Y variables do not participate in the packing process (the creation of the data tree).
// they are only used later on for speeding up the drawing process and interaction

class lrect {
  float W, H, A; // dimensions and area. WARNING: Area shows TRUE area occupied, as
  // in: Area occupied by lr1+lr2, or by self if leaf, NOT by W*H (which is different)
  float X=0,Y=0; // These are only to be used as helper variables to reduce calculations. 
  // The actual packing process ignores them.
  boolean direction; //0(false)=row cut, 1(true)=column cut
  boolean leaf; //Denotes a leaf in the tree structure (dimensions are important)
  boolean free; //Denotes a free leaf in the tree structure (dimensions are important)
  boolean capfront=false;
  boolean caprear=false;
  lrect lr1, lr2;
  lrect(lrect lr1in, lrect lr2in, boolean sdirin) { // 0=row cut, 1=column cut
    lr1=lr1in;
    lr2=lr2in;
    A=lr1.A+lr2.A;
    leaf=false;
    free=false;
    if (sdirin) {
      direction=true;
      W=lr1.W+lr2.W;
      H=max(lr1.H,lr2.H);
    } 
    else {
      direction=false;
      W=max(lr1.W,lr2.W);
      H=lr1.H+lr2.H;
    }
  }
  lrect(float Win, float Hin, boolean freein) {
    W=Win;
    H=Hin;
    A=W*H;
    if (!freein) {
      leaf=true;
      free=false;
    } 
    else {
      leaf=false;
      free=true;
    }
  }
  lrect() {
  }
  lrect(float Xin, float Yin, float Win, float Hin, boolean freein) {
    X=Xin;
    Y=Yin;
    W=Win;
    H=Hin;
    A=W*H;
    if (!freein) {
      leaf=true;
      free=false;
    } 
    else {
      leaf=false;
      free=true;
    }
  }
  public boolean insert(lrect lrin) {
    lrect lr=lrin;
    if (!leaf && !free) {
      boolean newlr = lr1.insert(lr);
      if (newlr) {
        return (true);
      }
      return(lr2.insert(lr));
    } 
    else {
      if (!free) {
        return (false);
      }
      if (lr.W>W || lr.H>H) {
        return (false);
      }
      if ((int)lr.W==(int)W && (int)lr.H==(int)H) {
        free=false;
        leaf=true;
        return(true);
      }
      float dw=W-lr.W;
      float dh=H-lr.H;
// Needs optimization. To create only nonzero free space.
      if (dw>dh) {
        free=false;
        leaf=false;
        direction=true;
        lr1=new lrect(lr,new lrect(lr.W,H-lr.H,true),false);
        lr2=new lrect(W-lr.W,H,true);
      } 
      else {
        free=false;
        leaf=false;
        direction=false;
        lr1=new lrect(lr,new lrect(W-lr.W,lr.H,true),true);
        lr2=new lrect(W,H-lr.H,true);
      }
      return(true);
    }
  }
  // Applies to self all object properties from the argument object
  public void clonefrom(lrect lrin) {
    lrect lr=lrin;
    W=lr.W;
    H=lr.H;
    A=lr.A;
    direction=lr.direction;
    leaf=lr.leaf;
    free=lr.free;
    if (!lr.free && !lr.leaf) {
      lr1=lr.lr1;
      lr2=lr.lr2;
    }
  }
  // Updates the dimensions (W,H,A) of the structure, based on the
  // dimensions of the leaf rectangles. (real dimensions)
  // Items affected are non-leaf non-free lrects and leaf lrects.
  // During this process, free areas are not taken into account. As a result,
  // free areas will not conform to the structure's dimensions, unless updatefree()
  // is called (look below v)
  // Does not affect positions (X,Y)
  public void updatedims() {
    if (!free && !leaf) {
      lr1.updatedims();
      lr2.updatedims();
      W=0; 
      H=0; 
      A=0;
      if (direction) {//column cut
        // Calculate dimensions
        if (!lr1.free) {
          W+=lr1.W;
          H=lr1.H;
          A+=lr1.A;
        }
        if (!lr2.free) {
          W+=lr2.W;
          H=max(H,lr2.H);
          A+=lr2.A;
        }
      } 
      else {//row cut
        // Calculate dimensions
        W=0; 
        H=0; 
        A=0;
        if (!lr1.free) {
          H+=lr1.H;
          W=lr1.W;
          A+=lr1.A;
        }
        if (!lr2.free) {
          H+=lr2.H;
          W=max(W,lr2.W);
          A+=lr2.A;
        }
      }
    }
  }
  //Swaps children.
  public void mirror() {
    lrect tlr=lr1;
    lr1=lr2;
    lr2=tlr;
  }
}

// This is essentially a line object with a reference to an lrect (the one above^), 
// in order to specify slicing lines to draw and interact with
class lline {
  float X1,Y1,X2,Y2;
  lrect lr;
  lline(float X1in, float  Y1in, float  X2in, float  Y2in, lrect lrin) {
    X1=X1in;
    X2=X2in;
    Y1=Y1in;
    Y2=Y2in;
    lr=lrin;
  }
}
// Completely removes all free areas
public void removefree(lrect lrin) {
  lrect lr=lrin;
  if (!lr.free && !lr.leaf) {
    removefree(lr.lr1);
    removefree(lr.lr2);  
    if (lr.lr1.free && lr.lr2.free) {
      lr.lr1=null;
      lr.lr2=null;
      lr.free=true;
      //println("rem");
    }
    else if (lr.lr1.free) {
      lr.clonefrom(lr.lr2);
    }
    else if (lr.lr2.free) {
      lr.clonefrom(lr.lr1);
    }
  }
}  
// A helper function that swaps characteristics of two lrects. Needs restruct()
public void lswap(lrect lr1in, lrect lr2in) {
  lrect lr1=lr1in;
  lrect lr2=lr2in;
  lrect lrt=new lrect();
  //
  lrt.clonefrom(lr2);
  //
  lr2.clonefrom(lr1);
  //
  lr1.clonefrom(lrt);
}

//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

// Recalculation function. Performs all steps necessary for the complete recalculation of item package.
public void recalc() {
    // The array of items has changed in some way. Recalculate solution
      pack = new lrect(2000,Hmax,true); // 2000 is a temporary crude solution to specifying an initial space
                                        // large enough to hold all the items.
      // Update the final array with the items to be packed.
      finrects=new ArrayList();
      for (int i=0, j=initrects.size();i<j;i++) {
        lrect lr=(lrect)initrects.get(i);
        finrects.add(new lrect(lr.W,lr.H, false));
      }
      // Set the total items counter
      itemstopack=finrects.size();
      // Start packing
      lpacker();
      // Reset helper arrays and repopulate them with the new data.
      restruct();
      // The array is up to date
      change=false;
}

// A general restructuring function that performs all helper and maintenance
// subroutines on the pack, in order to keep it up to date after eg. an edit function
// or a pack function. Also calls functions to create arrays. Does not perform packing.
public void restruct() {
  // Reset temporary data structures
  finrects=new ArrayList();
  caprects=new ArrayList();
  lines=new ArrayList();
  // Reset counter
  packeditems=0;
  //
  removefree(pack); // Remove the structure's free areas
  pack.updatedims(); // Update structure dimensions
  createlparts(pack,0,0,pack.W,pack.H);    // Create the temporary arrays holding the items
}

// Recursive function that creates arrays of all items to be drawn after
// processing, in order to speed up drawing and simplify interaction.
// Also allows for simpler interaction by allowing direct reference of items.
public void createlparts(lrect lrin, float Xin, float Yin, float Win, float Hin) {
  lrect lr = lrin;
  lr.X=Xin;
  lr.Y=Yin;
  if (lr.leaf) { //is final(a leaf)
    // Set the items X,Y helper variables to the correct values
    finrects.add(lr);
    lrect tlr=new lrect(Xin,Yin,Win,Hin,false);
    tlr.caprear=lr.caprear;
    tlr.capfront=lr.capfront;
    caprects.add(tlr);
    packeditems++;
  }  
  else if (lr.free) {}
  // There is a tricky thing here
  // The difference between Win, Hin and lr.W, lr.H
  // Children of lrect have a dimensional analogy between them, which is
  // the ratio of the total width to the child's width in column cut, or accordingly the total height to the child's height when in row cut.
  // This ratio expresses where the separation line (between the two useful
  // spaces) will be placed. By using the same ratio, but with larger dimensions, it is possible
  // to evenly distribute excess space.
  // In this case, Win and Hin are dimensions specified initially, and the first time are usually the same
  // as the total dimensions of the pack, while lr.W and lr.H are the real dimensions of the objects.
  else if (!lr.direction) { // row cut
    float slice=lr.lr1.H/lr.H;
    createlparts(lr.lr1, Xin, Yin, Win, Hin*slice);
    createlparts(lr.lr2, Xin, Yin+Hin*slice, Win, Hin*(1-slice));
    if (!lr.lr1.free && !lr.lr2.free) {
      lines.add(new lline(Xin,Yin+Hin*slice,Xin+Win,Yin+Hin*slice,lr));
    }
  } 
  else { //column cut
    float slice=lr.lr1.W/lr.W;
    createlparts(lr.lr1, Xin, Yin, Win*slice, Hin);
    createlparts(lr.lr2, Xin+Win*slice, Yin, Win*(1-slice), Hin);
    if (!lr.lr1.free && !lr.lr2.free) {
      lines.add(new lline(Xin+Win*slice,Yin,Xin+Win*slice,Yin+Hin,lr));
    }
  }
}
//CHANGED!!!LEAST AREA
// Performs packing using various sorting methods and choosing the best result (least area);
public void lpacker() {
  ArrayList finrectsw=(ArrayList)finrects.clone();
  ArrayList finrectsh=(ArrayList)finrects.clone();
  ArrayList finrectsa=(ArrayList)finrects.clone();
  ArrayList finrectsp=(ArrayList)finrects.clone();
  ArrayList finrectss=(ArrayList)finrects.clone();
  bubblesortw(finrectsw);
  bubblesorth(finrectsh);
  bubblesorta(finrectsa);
  bubblesortp(finrectsp);
  bubblesorts(finrectss);
  lrect packw=new lrect(20000,Hmax,true);
  lrect packh=new lrect(20000,Hmax,true);
  lrect packa=new lrect(20000,Hmax,true);
  lrect packp=new lrect(20000,Hmax,true);
  lrect packs=new lrect(20000,Hmax,true);
  for (int i=0,j=finrects.size();i<j;i++) {
    lrect lrw=(lrect)finrectsw.get(i);
    packw.insert(lrw);
    lrect lrh=(lrect)finrectsh.get(i);
    packh.insert(lrh);
    lrect lra=(lrect)finrectsa.get(i);
    packa.insert(lra);
    lrect lrp=(lrect)finrectsp.get(i);
    packp.insert(lrp);
    lrect lrs=(lrect)finrectss.get(i);
    packs.insert(lrs);
  }
  packw.updatedims();
  packh.updatedims();
  packa.updatedims();
  packp.updatedims();
  packs.updatedims();

  pack=packw;
  if (packh.A<pack.A) {
    pack=packh;
  }
  if (packa.A<pack.A) {
    pack=packa;
  }
  if (packp.A<pack.A) {
    pack=packp;
  }
  if (packs.A<pack.A) {
    pack=packs;
  }
}
public void textrender(String title, String line1, String line2) {
  fill(255);
  noStroke();
  textFont(font2, 20);
  text(title,10,height-40);
  textFont(font, 11);
  text(line1, 10, height-25); 
    text(line2, 10, height-12); 
}

  static public void main(String args[]) {     PApplet.main(new String[] { "lpackern" });  }}