//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/


import processing.opengl.*;
import java.util.ArrayList;

PFont font, font2;                     // Fonts

float itemstopack=0, packeditems=0;    // Helper variables to display solution completeness
float scl=10;                          // Scale
float Xinit=0;                         // Scroll on mode 1
int Hmax=30;                           // Maximum height
int depth=10;                          // Depth in 3D
float zoom3=1;
float rot3=0;
int in=0;                              // A special helper variable that indicates whether a lrect is to be inserted
                                       // at the right or at the bottom, or to be swapped, when editing.
                                       // 0=swap, 1=bottom(row), 2=right(column)

ArrayList initrects=new ArrayList();   // Holds the unprocessed items
ArrayList finrects=new ArrayList();    // Holds the processed rectangle array
ArrayList caprects=new ArrayList();
ArrayList lines=new ArrayList();       // Holds the lines that separate finrects after processing
lrect pack=new lrect(100,Hmax,true);   // Initially specifies the free space, after processing
                                       //  stores the rectangle structure

int mode=0;                            // Denotes program mode
int tX=0, tY=0, tW=0, tH=0, dX=0, dY=0;// Helper variables to temporarily store dimensions of newly 
                                       //  created items or items that are being moved
boolean mouse=false;                   // Denotes a mousedown
boolean shift=false;
boolean draghmax=false;
boolean dragdepth=false;
boolean change=false;                  // Denotes a change in the initial array of finrects
boolean drawlines=true;                // Specifies drawing of lines
boolean drawrects=true;                // Specifies drawing of rectangles
lrect currentmouseover=null;           // Holds the item over which the cursor resides. Null if on none
lrect currentmousedrag=null;           // Holds the item which is dragged by the cursor. Null if none

void setup() {
  size(800,600, OPENGL);
  hint(ENABLE_OPENGL_4X_SMOOTH);
  this.frame.setTitle("LPacker"); 
  frameRate(20);
  font=loadFont("HelveticaNeue-11.vlw"); 
  font2=loadFont("HelveticaNeue-20.vlw"); 
}
void draw() {
  background(140);
  dX=mouseX-pmouseX;
  dY=mouseY-pmouseY;
  currentmouseover=null;
  if (mode==0) {
    draw1();
  } 
  else if (mode==1) {
    draw2();
  }
  else if (mode==2) {
    draw3();
  }
}
void mousePressed() {
  if (!mouse && (mode==0 || mode==2)) {
    tX=mouseX;
    tY=mouseY;
  }
  
  if (((mode==0 && tW==0 && tH==0) || (mode==1 && currentmousedrag==null)) && mouseY>Hmax*scl-5 && mouseY<Hmax*scl+5 && shift) {
    draghmax=true;
  } else if (((mode==0 && tW==0 && tH==0) || (mode==1 && currentmousedrag==null)) && mouseY>depth*scl-5 && mouseY<depth*scl+5 && shift) {
    dragdepth=true;
  }
  mouse=true;
}
void mouseDragged() {
  if (draghmax) {
    Hmax=(int)(mouseY/scl);
    recalc();
  } else if (dragdepth) {
    depth=(int)(mouseY/scl);
  } else if (mode==0) {
    tW=(int)((abs(mouseX-tX))/scl);
    tH=(int)((abs(mouseY-tY))/scl);
  } else if (mode==2 && mouse) {
      zoom3+=(float)dY/60;
      rot3+=(float)dX/5;
  } else if (mode==1 && shift) {
    Xinit+=(float)dX/3;
    if (Xinit>0) {Xinit=0;}
  }
}
void mouseReleased() {
  dragdepth=draghmax=false;
  if (mode==0) {
    if (tW>0 && tH>0) {
      initrects.add(new lrect(tX,tY,tW,tH,false));
      tW=tH=0;
      change=true;
    } 
    else {
      for (int i=0;i<initrects.size();i++) {
        lrect lr=(lrect)initrects.get(i);
        float dx2=(lr.X-mouseX);
        dx2*=dx2;
        float dy2=(lr.Y-mouseY);
        dy2*=dy2;
        if (dx2+dy2<256) {
          initrects.remove(i);
          change=true;
        }
      }
    }
  }  
  else if (mode==1) {
    if (currentmouseover!=null && mouseX>Xinit+currentmouseover.X*scl+5 && mouseX<Xinit+currentmouseover.X*scl+21 && mouseY>currentmouseover.Y*scl+21 && mouseY<currentmouseover.Y*scl+36) {
      currentmouseover.caprear=!currentmouseover.caprear;
    } else if (currentmouseover!=null && mouseX>Xinit+currentmouseover.X*scl+22 && mouseX<Xinit+currentmouseover.X*scl+38 && mouseY>currentmouseover.Y*scl+21 && mouseY<currentmouseover.Y*scl+36) {
      currentmouseover.capfront=!currentmouseover.capfront;
    } else if (currentmousedrag!=null && currentmouseover!=null) {
      if (currentmouseover.leaf) {
        if (in==0) {
        lswap(currentmousedrag, currentmouseover);
        restruct();
        } else if (in==1 && currentmouseover!=currentmousedrag) {
          lrect lrt=new lrect();
          lrect lrt2=new lrect();
          lrt.clonefrom(currentmouseover);
          lrt2.clonefrom(currentmousedrag);
          lrect lrt3=new lrect(lrt,lrt2,false);
          currentmouseover.clonefrom(lrt3);
          currentmousedrag.free=true;
          restruct();
        } else if (in==2 && currentmouseover!=currentmousedrag) {
          lrect lrt=new lrect();
          lrect lrt2=new lrect();
          lrt.clonefrom(currentmouseover);
          lrt2.clonefrom(currentmousedrag);
          lrect lrt3=new lrect(lrt,lrt2,true);
          currentmouseover.clonefrom(lrt3);
          currentmousedrag.free=true;
          restruct();
        }
      } else if (currentmouseover.lr1!=currentmousedrag){
        lrect lrt1=new lrect();
        lrect lrt2=new lrect();
        lrt1.clonefrom(currentmouseover.lr1);
        lrt2.clonefrom(currentmousedrag);
        currentmouseover.lr1=new lrect(lrt1,lrt2,currentmouseover.direction);
        currentmousedrag.free=true;
        restruct();
        
      }
    }
    else if (currentmouseover!=null) {
      currentmouseover.mirror();
      restruct();
      currentmouseover=null;
    }
  }
  mouse=false;
  currentmousedrag=null;
}


void keyPressed() {
  if (key==CODED && keyCode==SHIFT) {
    shift=true;
  }
  if (key=='1') {
    // Enter draw mode
    mode=0;
    tX=tY=tW=tH=0;
  } 
  else if (key=='2') {
    // Enter packing mode
    mode=1;
    if (change) {
    recalc();
    }
  }
  else if (key=='3') {
   // Enter 3D mode
   mode=2;
   if (change) {
    recalc();
    } 
  }
  // Draw positioned items
  else if (key=='q') {
    drawrects=!drawrects;
  } 
  // Draw separation lines
  else if (key=='w') {
    drawlines=!drawlines;
  }
}

void keyReleased() {
  shift=false;
}
